/*
	loader.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "common.h"

EXPORT	TC		*TADdata = NULL;
EXPORT	W		TADsize;
EXPORT	TR_VOBJREC	*VOBJdata = NULL;
EXPORT	W		VOBJentry;


/* $B%U%!%$%k$N%m!<%I(B */
EXPORT	ERR	load_file(TC *filename)
{
	W	err, i, fd;
	LINK	l;
	F_STATE	fs;

	/* $B%"%s%m!<%I=hM}(B */
	if (filename == NULL) {
		err = ER_OK;
		fd = ER_NOEXS;
		goto fin3;
	}

	/* $BF~NO%U%!%$%k$X$N%j%s%/<h$j=P$7(B */
	err = get_lnk(filename, &l, F_NORM);
	if (err < ER_OK) {
		P(("load_file: get_lnk %d\n", err));
		goto fin0;
	}

	/* $BF~NO%U%!%$%k$N%*!<%W%s(B - $B8=:_%l%3!<%I$O%U%!%$%k$N@hF,(B */
	err = opn_fil(&l, F_READ | F_EXCL, NULL);
	if (err < ER_OK) {
		P(("load_file: opn_fil %d\n", err));
		goto fin0;
	}
	fd = err;

	/* $B%j%s%/%U%!%$%k?t$N3MF@(B */
	err = ofl_sts(fd, NULL, &fs, NULL);
	if (err < ER_OK) {
		P(("load_file: ofl_sts %d\n", err));
		goto fin1;
	}

	/* $B%j%s%/%U%!%$%kMQNN0h$N3NJ](B */
	VOBJentry = fs.f_nlink;
	if (VOBJentry) {
		VOBJdata = calloc(VOBJentry, sizeof(TR_VOBJREC));
		if (VOBJdata == NULL) {
			P(("load_file: calloc NULL\n"));
			err = ER_NOMEM;
			goto fin1;
		}
	} else {
		VOBJdata = NULL;
	}

	/* $BA4%j%s%/%U%!%$%k$NFI$_=P$7(B */
	for (i = 0; i < VOBJentry; i++) {
		err = fnd_lnk(fd, F_FWD, NULL, 0, NULL);
		if (err < ER_OK) {
			P(("load_file: fnd_lnk %d\n", err));
			goto fin2;
		}

		err = rea_rec(fd, 0, (B *)&VOBJdata[i].vlnk, sizeof(VLINK),
			      NULL, NULL);
		if (err < ER_OK) {
			P(("load_file: rea_rec %d\n", err));
			goto fin2;
		}

		err = see_rec(fd, 1, 0, NULL);
		if (err < ER_OK) {
			P(("load_flie: see_rec %d\n", err));
			goto fin2;
		}
	}

	/* $B<g(BTAD$B%l%3!<%I$X0\F0(B */
	err = fnd_rec(fd, F_ENDTOP, (1 << 1), 0, NULL);
	if (err < ER_OK) {
		P(("load_file: fnd_rec %d\n", err));
		goto fin2;
	}

	/* $B%l%3!<%I%5%$%:$N<hF@(B */
	err = rea_rec(fd, 0, NULL, 0, &TADsize, NULL);
	if (err < ER_OK) {
		P(("load_file: rea_rec %d\n", err));
		goto fin2;
	}

	/* $B%a%b%j$N3NJ](B */
	TADdata = malloc(TADsize);
	if (TADdata == NULL) {
		P(("load_file: malloc NULL\n"));
		err = ER_NOMEM;
		goto fin2;
	}

	/* $B%l%3!<%IA4BN$NFI$_9~$_(B */
	err = rea_rec(fd, 0, (B *)TADdata, TADsize, NULL, NULL);
	if (err < ER_OK) {
		P(("load_file: rea_rec %d\n", err));
		goto fin3;
	}

	DP(("load_file: TADsize %d, VOBJentry %d\n", TADsize, VOBJentry));

	/* $B%U%!%$%k$r%/%m!<%:$7$F=*N;(B */
	goto fin1;	

fin3:
	if (TADdata != NULL) {
		free(TADdata);
		TADdata = NULL;
	}
fin2:
	if (VOBJdata != NULL) {
		free(VOBJdata);
		VOBJdata = NULL;
	}
fin1:
	if (fd >= 0) cls_fil(fd);
fin0:
	return err;
}
