/*
	main.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "common.h"

/* main entry */
EXPORT	W	main(W ac, TC *av[])
{
	W	err, nrec;
	TRAYREC	*tray;

	/* $B%X%k%W$NI=<((B */
	if (ac < 3) {
		P(("usage: %S [option] [filename]\n", av[0]));
		err = ER_PAR;
		goto fin0;
	}

	/* $B%*%W%7%g%s$N%A%'%C%/(B */
	// XXX

	/* TAD$B%G!<%?$NFI$_=P$7(B */
	err = load_file(av[2]);
	if (err < ER_OK) goto fin0;

	/* $B2r@O(B */
	err = parse(NULL, TADdata, TADsize, 0);
	if (err <= 0) {
		P(("main: parse %d\n", err));
		goto fin1;
	}
	nrec = err;

	/* $B%H%l!<%l%3!<%I3JG<NN0h$N3NJ](B */
	tray = calloc(nrec, sizeof(TRAYREC));
	if (tray == NULL) {
		P(("main: calloc NULL\n"));
		err = ER_NOMEM;
		goto fin1;
	}

	/* $B%H%l!<%l%3!<%I9=C[(B */
	err = parse(tray, TADdata, TADsize, 0);
	if (err != nrec) {
		P(("main: parse %d <- %d\n", err, nrec));
		err = ER_OBJ;
		goto fin2;
	}

	/* $BKvC<$NJ8>O!??^7A=*N;%;%0%a%s%H$r>JN,$9$k(B */
	switch (tray[nrec - 1].id) {
	case	TS_TEXTEND:
	case	TS_FIGEND:
		nrec--;
		break;
	default:
		/* do nothing */
		break;
	}

	/* $B%H%l!<$X$NE>Aw(B */
	err = tpsh_dat(tray, nrec, NULL);
	if (err < ER_OK) {
		P(("main: tpsh_dat %d\n", err));
		goto fin2;
	}

	err = ER_OK;
fin2:
	free(tray);
fin1:
	load_file(NULL);
fin0:
	return err;
}
